<!DOCTYPE html>
<html lang="en" class="antialiased">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>DEEPAK </title>
    <meta name="description" content="">
    <meta name="keywords" content="">
    <link href="https://unpkg.com/tailwindcss@2.2.19/dist/tailwind.min.css" rel=" stylesheet">
    <!--Replace with your tailwind.css once created-->


    <!--Regular Datatables CSS-->
    <link href="https://cdn.datatables.net/1.10.19/css/jquery.dataTables.min.css" rel="stylesheet">
    <!--Responsive Extension Datatables CSS-->
    <link href="https://cdn.datatables.net/responsive/2.2.3/css/responsive.dataTables.min.css" rel="stylesheet">

    <style>
    /*Overrides for Tailwind CSS */

    /*Form fields*/
    .dataTables_wrapper select,
    .dataTables_wrapper .dataTables_filter input {
        color: #4a5568;
        /*text-gray-700*/
        padding-left: 1rem;
        /*pl-4*/
        padding-right: 1rem;
        /*pl-4*/
        padding-top: .5rem;
        /*pl-2*/
        padding-bottom: .5rem;
        /*pl-2*/
        line-height: 1.25;
        /*leading-tight*/
        border-width: 2px;
        /*border-2*/
        border-radius: .25rem;
        border-color: #edf2f7;
        /*border-gray-200*/
        background-color: #edf2f7;
        /*bg-gray-200*/
    }

    /*Row Hover*/
    table.dataTable.hover tbody tr:hover,
    table.dataTable.display tbody tr:hover {
        background-color: #ebf4ff;
        /*bg-indigo-100*/
    }

    /*Pagination Buttons*/
    .dataTables_wrapper .dataTables_paginate .paginate_button {
        font-weight: 700;
        /*font-bold*/
        border-radius: .25rem;
        /*rounded*/
        border: 1px solid transparent;
        /*border border-transparent*/
    }

    /*Pagination Buttons - Current selected */
    .dataTables_wrapper .dataTables_paginate .paginate_button.current {
        color: #fff !important;
        /*text-white*/
        box-shadow: 0 1px 3px 0 rgba(0, 0, 0, .1), 0 1px 2px 0 rgba(0, 0, 0, .06);
        /*shadow*/
        font-weight: 700;
        /*font-bold*/
        border-radius: .25rem;
        /*rounded*/
        background: #667eea !important;
        /*bg-indigo-500*/
        border: 1px solid transparent;
        /*border border-transparent*/
    }

    /*Pagination Buttons - Hover */
    .dataTables_wrapper .dataTables_paginate .paginate_button:hover {
        color: #fff !important;
        /*text-white*/
        box-shadow: 0 1px 3px 0 rgba(0, 0, 0, .1), 0 1px 2px 0 rgba(0, 0, 0, .06);
        /*shadow*/
        font-weight: 700;
        /*font-bold*/
        border-radius: .25rem;
        /*rounded*/
        background: #667eea !important;
        /*bg-indigo-500*/
        border: 1px solid transparent;
        /*border border-transparent*/
    }

    /*Add padding to bottom border */
    table.dataTable.no-footer {
        border-bottom: 1px solid #e2e8f0;
        /*border-b-1 border-gray-300*/
        margin-top: 0.75em;
        margin-bottom: 0.75em;
    }

    /*Change colour of responsive icon*/
    table.dataTable.dtr-inline.collapsed>tbody>tr>td:first-child:before,
    table.dataTable.dtr-inline.collapsed>tbody>tr>th:first-child:before {
        background-color: #667eea !important;
        /*bg-indigo-500*/
    }
    </style>



</head>

<body class="bg-gray-100 text-gray-900 tracking-wider leading-normal">

    <div class='bg-gray-200 min-h-screen flex flex-col items-center justify-center '>
        <div class='w-[420px] bg-white p-8 rounded-2xl  flex flex-col gap-12 '>
            <div class='text-center'>
                <h1 class='text-2xl font-medium'>Upload Your CSV Files</h1>
                <p class='text-gray-400 '>Files Should be less than 5 MB</p>
            </div>
            <div
                class='w-full p-12 border-2 rounded-2xl group flex flex-col items-center justify-center border-dashed border-blue-400 relative'>
                <input type="file" id="fileInput" name="file" class="w-full h-full absolute opacity-0 cursor-pointer"
                    accept=".csv" />
                <svg class='w-14 aspect-square group-hover:scale-105' viewBox="0 0 48 48"
                    xmlns="http://www.w3.org/2000/svg">
                    <g id="Open_Folder-2" data-name="Open Folder">
                        <path
                            d="m45 18h-4v-4a2.996 2.996 0 0 0 -3-3h-15.25a2.9991 2.9991 0 0 1 -2.33-1.11l-1.96-2.41a3.9846 3.9846 0 0 0 -3.1-1.48h-11.36a2.996 2.996 0 0 0 -3 3v29.57a3.3672 3.3672 0 0 0 1.01 2.42 3.3672 3.3672 0 0 0 2.42 1.01h33.66a3.441 3.441 0 0 0 3.3-2.47l5.53-18.97a2.003 2.003 0 0 0 -1.92-2.56z"
                            fill="#376cfb" />
                        <path
                            d="m44.9987 18h-28.4262a3.43 3.43 0 0 0 -3.2925 2.47l-5.56 19.0614a3.4286 3.4286 0 0 1 -3.2914 2.4686h33.6638a3.43 3.43 0 0 0 3.2933-2.47l5.5331-18.97a2 2 0 0 0 -1.9201-2.56z"
                            fill="#4294ff" />
                    </g>
                </svg>
                <p class='text-gray-400'>Drag & Drop your files here</p>
            </div>

            <div class='flex flex-col gap-4'>
                <div class='w-full rounded-2xl flex flex-col gap-2' id="progressWrapper" style="display: none;">
                    <p class='text-gray-500'>Upload Status</p>
                    <div class='flex flex-col gap-3'>
                        <div class='flex items-end gap-2'>
                            <!-- <svg class='w-10 aspect-square' viewBox="0 0 791.454 791.454"
                                xmlns="http://www.w3.org/2000/svg">
                                <g>
                                    <g id="Vrstva_x0020_1_30_">
                                        <path clip-rule="evenodd"
                                            d="m202.63 0h264.877l224.149 233.97v454.364c0 56.904-45.927 103.12-102.831 103.12h-386.195c-56.615 0-102.831-46.216-102.831-103.12v-585.503c-.001-56.615 46.216-102.831 102.831-102.831z"
                                            fill="#00733b" fill-rule="evenodd" />
                                        <g fill="#fff">
                                            <path clip-rule="evenodd" d="m467.218 0v231.948h224.438z"
                                                fill-rule="evenodd" opacity=".302" />
                                            <path
                                                d="m345.9 576.26h-38.417l-26.285-44.194-26.286 44.194h-38.706l45.639-76.835-40.15-66.725h38.705l20.797 34.662 20.508-34.662h38.706l-39.862 67.014zm13.576 0v-143.56h36.684v112.363h62.392v31.196h-99.076zm159.735 1.733c-14.443 0-27.152-4.622-38.128-13.576-10.688-8.666-16.753-19.642-17.62-32.64l31.485-9.243c.867 6.932 3.755 12.998 8.666 17.62 5.199 4.622 10.976 6.932 17.331 6.932 5.199 0 9.532-1.155 12.998-3.466 3.177-2.311 4.91-5.488 4.91-9.243 0-3.177-1.444-5.777-4.044-8.088-2.6-2.022-6.066-3.755-10.11-5.199s-8.954-2.889-13.865-4.044c-5.199-1.444-10.399-3.177-15.309-5.488-5.199-2.022-9.821-4.622-13.865-7.799-4.333-2.889-7.51-7.221-10.11-12.71-2.6-5.199-4.044-11.554-4.044-18.775 0-11.843 4.91-21.664 15.02-29.463 10.11-8.088 22.242-11.843 36.395-11.843 14.154 0 26.574 3.466 36.973 10.11 10.399 6.932 17.042 15.887 19.642 26.863l-32.929 13.865c-1.444-6.066-4.333-10.976-8.377-14.731-4.044-3.466-9.243-5.488-15.309-5.488-4.622 0-8.088 1.155-10.976 2.889-2.6 1.733-3.755 4.333-3.755 7.51 0 2.889 1.733 5.488 5.199 7.51 3.466 1.733 8.088 3.177 13.287 4.044s10.976 2.311 17.042 4.333c6.355 2.311 11.843 4.622 17.331 7.799 5.199 2.889 9.532 7.799 12.998 14.154 3.755 6.644 5.488 14.443 5.488 23.397 0 13.287-5.199 24.264-15.598 32.351s-23.972 12.419-40.726 12.419z" />
                                        </g>
                                    </g>
                                </g>
                            </svg> -->
                            <div class='w-full space-y-1'>
                                <div class='flex justify-between'>
                                    <span></span>
                                    <span class='font-normal text-gray-500 ' id="progressNumber">0%</span>
                                </div>
                                <div class='h-2 w-full bg-gray-300 rounded-md'>
                                    <div class='h-2 bg-green-600 rounded-md' id="progressBar" style="width: 0%"></div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="w-full">
                    <p class="text-md font-normal" id="uploadStatus"></p>
                </div>

            </div>
        </div>
    </div>



    <!--Container-->
    <div class="container w-full mx-auto px-2 timesheet-list-view">
        <!--Title-->
        <div class="py-8"></div>
        <!--Card-->
        <div id='recipients' class="p-8 mt-6 lg:mt-0 rounded shadow bg-white">
            <table id="listView" class="stripe hover" style="width:100%; padding-top: 1em;  padding-bottom: 1em;">
                <thead>
                    <tr>
                        <th data-priority="1">Date (DD-MM-YYYY)</th>
                        <th data-priority="2">Start Time</th>
                        <th data-priority="3">End Time</th>
                        <th data-priority="4">Project</th>
                        <th data-priority="5">Activity</th>
                        <th data-priority="6">Comments</th>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td><input
                                class="block w-full rounded-md border-0 py-1.5 pl-7 pr-20 text-gray-900 ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6"
                                type="date" name="dateIs[]" value="" /></td>
                        <td><input
                                class="block w-full rounded-md border-0 py-1.5 pl-7 pr-20 text-gray-900 ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6"
                                type="time" name="startTimeIs[]" value="" /></td>
                        <td><input
                                class="block w-full rounded-md border-0 py-1.5 pl-7 pr-20 text-gray-900 ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6"
                                type="time" name="endTimeIs[]" value="" /></td>
                        <td><input
                                class="block w-full rounded-md border-0 py-1.5 pl-7 pr-20 text-gray-900 ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6"
                                type="text" name="project[]" value="" /></td>
                        <td><input
                                class="block w-full rounded-md border-0 py-1.5 pl-7 pr-20 text-gray-900 ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6"
                                type="text" name="activity[]" value="" /></td>
                        <td><textarea
                                class="block w-full rounded-md border-0 py-1.5 pl-7 pr-20 text-gray-900 ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6"
                                type="date" name="comments[]"></textarea></td>
                    </tr>

                </tbody>
            </table>

            <div class="flex justify-center gap-2">
                <button type="button"
                    class="rounded-lg px-8 py-3 bg-green-700 text-green-100 hover:bg-green-800 duration-300 text-md"
                    id="export-data">Export</button>
                <button type="button"
                    class="rounded-lg px-8 py-3 bg-green-700 text-green-100 hover:bg-green-800 duration-300 text-md"
                    id="exportCSV">Export</button>
            </div>
            <div class="w-full my-4">
                <p class="text-md font-normal" id="exportStatus"></p>
            </div>
        </div>
        <!--/Card-->
    </div>
    <!--/container-->

    <!-- jQuery -->
    <script type="text/javascript" src="https://code.jquery.com/jquery-3.4.1.min.js"></script>

    <!--Datatables -->
    <script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/responsive/2.2.3/js/dataTables.responsive.min.js"></script>
    <script>
    $(document).ready(function() {
        const rootPath = window.location.href.replace("index.php", "");

        const formatDate = (dateString) => {
            let [day, month, year] = dateString.split('.');
            return `${day}-${month}-${year}`;
        };

        const getTimeFromRange = (timeString, position) => {
            if (timeString) {
                let times = timeString.split(', ');
                return position === 'start' ? times[0] : times[times.length - 1];
            }
            return "";
        };

        const generateInput = (name, value, type = 'text') => {
            return `<input class="block w-full rounded-md border-0 py-1.5 pl-7 pr-20 text-gray-900 ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" type="${type}" name="${name}[]" value="${value}">`;
        };

        const generateTextArea = (name) => {
            return `<textarea class="block w-full rounded-md border-0 py-1.5 pl-7 pr-20 text-gray-900 ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" name="${name}[]"></textarea>`;
        };

        const parseTime = (timeStr) => {
            let date = new Date();
            let [time, period] = timeStr.split(' ');
            let [hours, minutes] = time.split(':').map(Number);

            if (period === 'PM' && hours < 12) hours += 12;
            if (period === 'AM' && hours === 12) hours = 0;

            date.setHours(hours, minutes, 0, 0);
            return date;
        };

        const formatTime = (date) => {
            let hours = date.getHours();
            let minutes = date.getMinutes().toString().padStart(2, '0');
            let period = hours >= 12 ? 'PM' : 'AM';

            hours = hours % 12 || 12;
            return `${hours}:${minutes} ${period}`;
        };

        const generateTimeSlots = (startTime, endTime, incrementMinutes) => {
            let slots = [];
            let start = parseTime(startTime);
            let end = parseTime(endTime);

            while (start < end) {
                slots.push(formatTime(start));
                start.setMinutes(start.getMinutes() + incrementMinutes);
            }

            return slots;
        };

        $('#fileInput').on('change', function() {
            let fileInput = $('#fileInput')[0];
            if (fileInput.files.length === 0) {
                alert('Please select a file.');
                return;
            }

            let formData = new FormData();
            formData.append('file', fileInput.files[0]);
            $('#progressWrapper').show();

            let dataTableOptions = {
                paging: true,
                searching: true,
                ordering: true,
                lengthChange: true,
                info: false,
                pageLength: 500,
                responsive: true
            };

            if ($.fn.DataTable.isDataTable('#listView')) {
                $('#listView').DataTable().destroy();
            }

            let dataTable = $('#listView').DataTable(dataTableOptions).columns.adjust().responsive
                .recalc();

            $.ajax({
                url: `${rootPath}_ajax/upload.php`,
                type: 'POST',
                data: formData,
                processData: false,
                contentType: false,
                xhr: function() {
                    let xhr = new XMLHttpRequest();
                    xhr.upload.addEventListener('progress', function(e) {
                        if (e.lengthComputable) {
                            let percentComplete = (e.loaded / e.total) * 100;
                            $('#progressNumber').html(`${percentComplete}%`);
                            $('#progressBar').css('width', `${percentComplete}%`);
                        }
                    }, false);
                    return xhr;
                },
                success: function(response) {
                    dataTable.clear();
                    if (response.success) {
                        $('#uploadStatus').html(`<p>${response.status_text}</p>`);
                        response.data0.forEach(data => {
                            const [employeeId, employeeName, date, start, end] =
                            data;
                            const punchDate = formatDate(date);
                            const startTime = getTimeFromRange(start, 'start');
                            const endTime = getTimeFromRange(end, 'end');
                            if (startTime && endTime) {
                                let timeSlots = generateTimeSlots(startTime,
                                    endTime, 30);
                                timeSlots.forEach((slot, i) => {
                                    if (i < timeSlots.length - 1) {
                                        dataTable.row.add([
                                            generateInput('dateIs',
                                                punchDate),
                                            generateInput(
                                                'startTimeIs', slot
                                            ),
                                            generateInput(
                                                'endTimeIs',
                                                timeSlots[i + 1]),
                                            generateInput('project',
                                                'Compassion'),
                                            generateInput(
                                                'activity',
                                                'Code development'),
                                            generateTextArea(
                                                'comments')
                                        ]).draw(false);
                                    }
                                });
                                dataTable.row.add([
                                    generateInput('dateIs', punchDate),
                                    generateInput('startTimeIs', timeSlots[
                                        timeSlots.length - 1]),
                                    generateInput('endTimeIs', endTime),
                                    generateInput('project', 'Compassion'),
                                    generateInput('activity',
                                        'Code development'),
                                    generateTextArea('comments')
                                ]).draw(false);
                            }
                        });
                    } else {
                        $('#uploadStatus').html(`<p>${response.status_text}</p>`);
                    }
                },
                error: function() {
                    $('#uploadStatus').html(
                        '<p>An error occurred while uploading the file.</p>');
                }
            });
        });

        // Function to generate a CSV string from data
        function generateCSV(data) {
            // Initialize CSV string with header row
            let csv = 'Date,Start Time,End Time,Project,Activity,Comments\n';

            // Loop through the data and add rows to the CSV string
            data.forEach(row => {
                console.log("row : ", row);
                csv +=
                    `${row[0]},${row[1]},${row[2]},${row[3]},${row[4]},${row[5]}\n`;
            });

            return csv;
        }

        // Function to download CSV file
        function downloadCSV(csvContent, filename) {
            // Create a Blob containing the CSV data
            const blob = new Blob([csvContent], {
                type: 'text/csv;charset=utf-8;'
            });

            // Create a temporary URL for the Blob
            const url = URL.createObjectURL(blob);

            // Create a link element
            const link = document.createElement('a');

            // Set the link's attributes
            link.setAttribute('href', url);
            link.setAttribute('download', filename);

            // Simulate a click on the link to trigger download
            link.click();

            // Cleanup
            URL.revokeObjectURL(url);
        }

        // Function to extract values from DataTable rows
        function extractRowValues(row) {
            const rowData = [];

            // Iterate over each column in the row
            $(row).find('input, textarea').each(function() {
                // Push the value of each input/textarea to the rowData array
                rowData.push($(this).val());
            });

            return rowData;
        }

        // Event handler for CSV export button
        $('#exportCSV').on('click', function() {
            // Collect data from DataTable
            // let dataTable = $('#listView').DataTable();
            // let data = dataTable.rows().data().toArray();

            // // Map the data to extract input values
            // let csvData = data.map(row => extractRowValues(row));

            // Get all elements with the name 'dateIs[]'
            const dateIs = document.getElementsByName('dateIs[]');
            const startTimeIs = document.getElementsByName('startTimeIs[]');
            const endTimeIs = document.getElementsByName('endTimeIs[]');
            const project = document.getElementsByName('project[]');
            const activity = document.getElementsByName('activity[]');
            const comments = document.getElementsByName('comments[]');

            const csvData = [];

            // Iterate through the NodeList and collect the values
            for (let i = 0; i < dateIs.length; i++) {
                const value = [];
                value.push(dateIs[i].value);
                value.push(startTimeIs[i].value);
                value.push(endTimeIs[i].value);
                value.push(project[i].value);
                value.push(activity[i].value);
                value.push(comments[i].value);
                csvData.push(value);
            }

            // Generate CSV content (similar to previous implementation)
            let csvContent = generateCSV(csvData);


            // Get current date and format it as "MMM-yyyy"
            const now = new Date();
            const monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct",
                "Nov", "Dec"
            ];
            const month = monthNames[now.getMonth()];
            const year = now.getFullYear();
            const formattedDate = `${month}-${year}`;

            // Create a filename using the formatted date
            const filename = `exportme_${formattedDate}.csv`;

            // Download CSV file (similar to previous implementation)
            downloadCSV(csvContent, filename);
        });

        $('#export-data').on('click', function() {

            const pointThis = $(this);

            // Get all elements with the name 'dateIs[]'
            const dateIs = document.getElementsByName('dateIs[]');
            const startTimeIs = document.getElementsByName('startTimeIs[]');
            const endTimeIs = document.getElementsByName('endTimeIs[]');
            const project = document.getElementsByName('project[]');
            const activity = document.getElementsByName('activity[]');
            const comments = document.getElementsByName('comments[]');

            const values = [];

            // Iterate through the NodeList and collect the values
            for (let i = 0; i < dateIs.length; i++) {
                const value = [];
                value.push(dateIs[i].value);
                value.push(startTimeIs[i].value);
                value.push(endTimeIs[i].value);
                value.push(project[i].value);
                value.push(activity[i].value);
                value.push(comments[i].value);
                values.push(value);
            }

            // Print the values to the console
            console.log(values);

            let formData = new FormData();
            formData.append('timesheetData', values);

            $.ajax({
                url: `${rootPath}_ajax/export.php`,
                type: 'POST',
                data: formData,
                processData: false,
                contentType: false,
                xhr: function() {
                    let xhr = new XMLHttpRequest();
                    xhr.upload.addEventListener('progress', function(e) {
                        if (e.lengthComputable) {
                            let percentComplete = (e.loaded / e.total) * 100;
                            pointThis.html(`${percentComplete}%`);
                        }
                    }, false);
                    return xhr;
                },
                success: function(response) {


                    pointThis.html(`DONE Happy coding!`);
                },
                error: function() {
                    $('#exportStatus').html(
                        '<p>An error occurred while uploading the file.</p>');
                }
            });

        });

    });
    </script>

</body>

</html>